#version 450

layout (binding = 0) uniform UBO 
{
	mat4 projection;
	mat4 modelView;
	mat4 invModelView;
	vec4 cameraPosition;
	vec2 framebuffer_size;
	int envprobe;
	float polarization;
} ubo;
layout (binding = 1) uniform samplerCube samplerEnv[3];

layout (constant_id = 0) const int view_mode = 0;
layout (constant_id = 1) const int m = 1;

layout (location = 0) in vec3 inUVW;

layout (location = 0) out vec4 outColor;

void main() 
{
	const vec3 color = texture(samplerEnv[ubo.envprobe], inUVW).rgb;
	const vec3 energy_s = color * (1-ubo.polarization);
	const vec3 energy_p = color * ubo.polarization;

	vec3 energy;
	if (view_mode == 0)
		energy = energy_s + energy_p;
	else if (view_mode == 1)
		energy = energy_s + 0.001f * energy_p;
	else if (view_mode == 2)
		energy = 0.001f * energy_s + energy_p;

	outColor = vec4(energy, 1.0);
}
